; Platinum/theme.jl

;; Copyright (C) 2000 Ryan Lovett <ryan@ocf.berkeley.edu>

(let*
    (
     ;; fonts
     (font (get-font "-b&h-lucida-bold-r-normal-*-*-120-*-*-p-*-iso8859-1"))
     (t-font (get-font "-b&h-lucida-bold-r-normal-*-*-100-*-*-p-*-iso8859-1"))
     (font-colors (list (get-color "#6e6e6e") (get-color "black")))

     (title-width
      (lambda (w)
	(let
	    ((w-width (car (window-dimensions w))))
	  (max 0 (min (- w-width 100) (text-width (window-name w) font))))))
     
     (thumb-half-width
      (lambda (w)
	(/ (- (car (window-dimensions w)) (title-width w)) 2)))

     (update-text-width
      (lambda (w)
	(if (eq (window-get w 'current-frame-style) 'Platinum)
	    (rebuild-frame w))))
     
     ;; 3x7
     (bottom-images (list
		     (make-image "bottom_inactive.png")
		     (make-image "bottom.png")))
     
     ;; 6x7
     (bottom-left-images (list
			  (make-image "bl_inactive.png")
			  (make-image "bl.png")))
     
     ;; 7x7
     (bottom-right-images (list
			   (make-image "br_inactive.png")
			   (make-image "br.png")))
     
     ;; 6x3
     (left-images (list
		   (make-image "left_inactive.png")
		   (make-image "left.png")))
     
     ;; 7x3
     (right-images (list
		    (make-image "right_inactive.png")
		    (make-image "right.png")))
     
     ;; 6x22
     (top-left-images (list
		       (make-image "top_left_inactive.png")
		       (make-image "top_left.png")))
     
     ;; 2x22
     (top-thumb-inactive (make-image "top_thumb_inactive.png"))
     
     ;; 2x22
     (top-thumb-left-images (list
			     top-thumb-inactive
			     (make-image "top_thumb_left.png")))
     
     ;; 2x22
     (top-thumb-right-images (list
			      top-thumb-inactive
			      (make-image "top_thumb_right.png")))
     
     ;; 2x22
     (top-thumb-mid-images (list
			    top-thumb-inactive
			    (make-image "top_thumb_mid.png")))
     
     ;; 3x22
     (top-grey-images (list
		       (make-image "top_grey_inactive.png")
		       (make-image "top_grey.png")))
     
     ;; 7x22
     (top-right-images (list
			(make-image "top_right_inactive.png")
			(make-image "top_right.png")))

     ;; 13x13
     (button-inactive-image (make-image "button_inactive.png"))
     
     ;; 
     (shadow-colors (list (get-color "#555555") (get-color "#000000")))
     (t-shadow-colors (list (get-color "#555555") (get-color "#000000")))

     ;; 13x13
     (close-images (list
		    button-inactive-image
		    (make-image "close_normal.png")
		    nil
		    (make-image "close_active.png")))
     
     ;; 13x13
     (maximize-images (list
		       button-inactive-image
		       (make-image "maximize_normal.png")
		       nil
		       (make-image "maximize_active.png")))
     
     ;; 13x13
     (shade-images (list
		    button-inactive-image
		    (make-image "shade_normal.png")
		    nil
		    (make-image "shade_active.png")))

     ;; 4x23
     (s-left-images (list
		     (make-image "s_left_inactive.png")
		     (make-image "s_left.png")))
     
     ;; 2x23
     (s-top-inactive (make-image "s_top_inactive.png"))
     
     ;; 2x23
     (s-grey-images (list
		     s-top-inactive
		     (make-image "s_grey.png")))
     
     ;; 2x23
     (s-thumb-left-images (list
			   s-top-inactive
			   (make-image "s_thumb_left.png")))
     
     
     ;; 2x23
     (s-thumb-mid-images (list
			  s-top-inactive
			  (make-image "s_thumb_mid.png")))
     
     ;; 2x23
     (s-thumb-right-images (list
			    s-top-inactive
			    (make-image "s_thumb_right.png")))
     
     ;; 4x23
     (s-right-images (list
		      (make-image "s_right_inactive.png")
		      (make-image "s_right.png")))
     
     ;; 4x5
     (t-bottom-left-image (make-image "t_bl.png"))
     
     ;; 2x5
     (t-bottom-image (make-image "t_bottom.png"))
     
     ;; 5x5
     (t-bottom-right-image (make-image "t_br.png"))
     
     ;; 10x10
     (t-close-images (list
		      (make-image "t_close_normal.png")
		      (make-image "t_close_normal.png")
		      nil  
		      (make-image "t_close_active.png")))
     
     ;; 10x10
     (t-maximize-images (list
			 (make-image "t_maximize_normal.png")
			 (make-image "t_maximize_normal.png")
			 nil
			 (make-image "t_maximize_active.png")))
     
     ;; 10x10
     (t-shade-images (list
		      (make-image "t_shade_normal.png")
		      (make-image "t_shade_normal.png")
		      nil
		      (make-image "t_shade_active.png")))

     ;; 4x2
     (t-left-image (make-image "t_left.png"))

     ;; 5x2
     (t-right-image (make-image "t_right.png"))

     ;; 2x16
     (t-top-grey-image (make-image "t_top_grey.png"))

     ;; 4x16
     (t-top-left-image (make-image "t_top_left.png"))

     ;; 5x16
     (t-top-right-image (make-image "t_top_right.png"))

     ;; 3x16
     (t-top-thumb-image (make-image "t_top_thumb.png"))

     ;; 2x17
     (t-s-left-image (make-image "t_s_left.png"))

     ;; 2x17
     (t-s-grey-image (make-image "t_s_grey.png"))

     ;; 2x17
     (t-s-thumb-image (make-image "t_s_thumb.png"))

     ;; 2x17
     (t-s-right-image (make-image "t_s_right.png"))


     ;; frame layout

     (frame 
      `(
	;; top grey
	((background . ,top-grey-images)
	 (foreground . ,font-colors)
         (font . ,font)
	 (top-edge . -22)
	 (left-edge . -2)
	 (right-edge . -3)
	 (text . ,window-name)
	 (x-justify . center)
	 (y-justify . center)
	 (class . title))
	
	;; top-left corner
	((background . ,top-left-images)
	 (left-edge . -6)
	 (top-edge . -22)
	 (class . top-left-corner))
	
	;; Left top left thumb
	((background . ,top-thumb-left-images)
	 (top-edge . -22)
	 (left-edge . 15)
	 (width . 2)
	 (class . title))
	
	;; Left top mid thumb
	((background . ,top-thumb-mid-images)
	 (top-edge . -22)
	 (left-edge . 17)					
	 (width . ,(lambda (w) (- (thumb-half-width w) 22)))
	 (class . title))

	;; Left top right thumb
	((background . ,top-thumb-right-images)
	 (top-edge . -22)					
	 (left-edge . ,(lambda (w) (- (thumb-half-width w) 5)))
	 (width . 2)
	 (class . title))
      
	;; Right top left thumb
	((background . ,top-thumb-left-images)
	 (top-edge . -22)					
	 (right-edge . ,(lambda (w) (- (thumb-half-width w) 5)))
	 (width . 2)
	 (class . title))
	
	;; Right top mid thumb
	((background . ,top-thumb-mid-images)
	 (top-edge . -22)
	 (right-edge . 33)				
	 (width . ,(lambda (w) (- (thumb-half-width w) 38)))
	 (class . title))
      
	;; Right top right thumb
	((background . ,top-thumb-right-images)
	 (top-edge . -22)
	 (right-edge . 31)
	 (width . 2)
	 (class . title))
	
	;; top-right corner
	((background . ,top-right-images)
	 (right-edge . -6)
	 (top-edge . -22)
	 (class . top-right-corner))
	
	;; left border
	((background . ,left-images)
	 (left-edge . -6)
	 (top-edge . 0)
	 (bottom-edge . 0)
	 (class . left-border))
	
	;; right border
	((background . ,right-images)
	 (right-edge . -6)
	 (top-edge . 0)
	 (bottom-edge . 0)
	 (class . right-border))
	
	;; bottom border
	((background . ,bottom-images)
	 (left-edge . 0)
	 (right-edge . 0)
	 (bottom-edge . -6)
	 (class . bottom-border))
	
	;; bottom-left corner
	((background . ,bottom-left-images)
	 (left-edge . -6)
	 (bottom-edge . -6)
	 (class . bottom-left-corner))
	
	;; bottom-right corner
	((background . ,bottom-right-images)
	 (right-edge . -6)
	 (bottom-edge . -6)
	 (class . bottom-right-corner))
	
     ;; bottom shadow
     ((background . ,shadow-colors)
      (left-edge . -4)
      (right-edge . -7)
      (bottom-edge . -7)
      (height . 1))

     ;; right shadow
     ((background . ,shadow-colors)
      (right-edge . -7)
      (top-edge . -20)
      (bottom-edge . -7)
      (width . 1))

	;; shade button
	((background . ,shade-images)
	 (right-edge . -2)
	 (top-edge . -18)
         (class . shade-button))
;         (class . maximize-button))
	
	;; maximize button
	((background . ,maximize-images)
	 (right-edge . 14)
	 (top-edge . -18)
	 (class . maximize-button))
	
	;; delete button
	((background . ,close-images)
	 (left-edge . -2)
	 (top-edge . -18)
	 (class . close-button))
	))
  
  (shaped-frame
   `(
     ;; top grey
     ((background . ,s-grey-images)
      (top-edge . -22)
      (left-edge . -2)
      (right-edge . -3)
      (foreground . ,font-colors)
      (font . ,font)
      (text . ,window-name)
      (x-justify . center)
      (y-justify . center)
      (class . title))
     
     ;; left side
     ((background . ,s-left-images)
      (left-edge . -6)
      (top-edge . -22)
      (class . top-left-corner))
     
     ;; Left top left thumb
     ((background . ,s-thumb-left-images)
      (top-edge . -22)
      (left-edge . 15)
      (width . 2)
      (class . title))
     
     ;; Left top mid thumb
     ((background . ,s-thumb-mid-images)
      (top-edge . -22)
      (left-edge . 17)					
      (width . ,(lambda (w) (- (thumb-half-width w) 20)))
      (class . title))
	 
     ;; Left top right thumb
     ((background . ,s-thumb-right-images)
      (top-edge . -22)					
      (left-edge . ,(lambda (w) (- (thumb-half-width w) 5)))
      (width . 2)
      (class . title))
     
     ;; Right top left thumb
     ((background . ,s-thumb-left-images)
      (top-edge . -22)					
      (right-edge . ,(lambda (w) (- (thumb-half-width w) 5)))
      (width . 2)
      (class . title))
     
     ;; Right top mid thumb
     ((background . ,s-thumb-mid-images)
      (top-edge . -22)
      (right-edge . 33)					
      (width . ,(lambda (w) (- (thumb-half-width w) 38)))
      (class . title))
     
     ;; Right top right thumb
     ((background . ,s-thumb-right-images)
      (top-edge . -22)
      (right-edge . 31)
      (width . 2)
      (class . title))
     
     ;; top-right corner
     ((background . ,s-right-images)
      (right-edge . -6)
      (top-edge . -22)
      (class . top-right-corner))
     
     ;; bottom shadow
     ((background . ,shadow-colors)
      (left-edge . -4)
      (right-edge . -7)
      (top-edge . 0)
      (height . 1))

     ;; right shadow
     ((background . ,shadow-colors)
      (right-edge . -7)
      (top-edge . -20)
      (height . 21)
      (width . 1))

     ;; shade button
     ((background . ,shade-images)
      (right-edge . -2)
      (top-edge . -18)					
      (class . shade-button))
     
     ;; maximize button
     ((background . ,maximize-images)
      (right-edge . 14)
      (top-edge . -18)
      (class . maximize-button))
     
     ;; delete button
     ((background . ,close-images)
      (left-edge . -2)
      (top-edge . -18)
      (class . close-button))
     ))
  
  (transient-frame
   `(
     ;; top grey
     ((background . ,t-top-grey-image)
      (top-edge . -16)
      (left-edge . -2)
      (right-edge . -2)					
      (foreground . ,font-colors)					
      (font . ,t-font)
      (text . ,window-name)
      (x-justify . center)
      (y-justify . center)
      (class . title))
     
     ;; top-left corner
     ((background . ,t-top-left-image)
      (left-edge . -4)
      (top-edge . -16)
      (class . top-left-corner))
     
     ;; Left top thumb
     ((background . ,t-top-thumb-image)
      (top-edge . -16)
      (left-edge . 11)
      (width . ,(lambda (w) (- (thumb-half-width w) 5)))
      (class . title))
     
     ;; Right top mid thumb
     ((background . ,t-top-thumb-image)
      (top-edge . -16)
      (right-edge . 23)
      (width . ,(lambda (w) (- (thumb-half-width w) 18)))
      (class . title))
     
     ;; top-right corner
     ((background . ,t-top-right-image)
      (right-edge . -4)
      (top-edge . -16)
      (class . top-right-corner))
     
     ;; left border
     ((background . ,t-left-image)
      (left-edge . -4)
      (top-edge . 0)
      (bottom-edge . 0)
      (class . left-border))
     
     ;; right border
     ((background . ,t-right-image)
      (right-edge . -4)
      (top-edge . 0)
      (bottom-edge . 0)
      (class . right-border))
     
     ;; bottom border
     ((background . ,t-bottom-image)
      (left-edge . 0)
      (right-edge . 0)
      (bottom-edge . -4)
      (class . bottom-border))
     
     ;; bottom-left corner
     ((background . ,t-bottom-left-image)
      (left-edge . -4)
      (bottom-edge . -4)
      (class . bottom-left-corner))
     
     ;; bottom-right corner
     ((background . ,t-bottom-right-image)
      (right-edge . -4)
      (bottom-edge . -4)
      (class . bottom-right-corner))
     
     ;; bottom shadow
     ((background . "black")
      (left-edge . -2)
      (right-edge . -5)
      (bottom-edge . -5)
      (height . 1))

     ;; right shadow
     ((background . "black")
      (right-edge . -5)
      (top-edge . -14)
      (bottom-edge . -5)
      (width . 1))

     ;; shade button
     ((background . ,t-shade-images)
      (right-edge . -2)
      (top-edge . -13)					
      (class . shade-button))
;      (class . maximize-button))
     
     ;; maximize button
     ((background . ,t-maximize-images)
      (right-edge . 9)
      (top-edge . -13)
      (class . maximize-button))
     
     ;; delete button
     ((background . ,t-close-images)
      (left-edge . -2)
      (top-edge . -13)
      (class . close-button))
     ))
  
  (shaped-transient-frame
   `(
     ;; top grey
     ((background . ,t-s-grey-image)
      (top-edge . -16)
      (left-edge . -2)
      (right-edge . -2)
      (foreground . ,font-colors)
      (font . ,t-font)
      (text . ,window-name)
      (x-justify . center)
      (y-justify . center)
      (class . title))
     
     ;; Left
     ((background . ,t-s-left-image)
      (left-edge . -4)
      (top-edge . -16)
      (class . top-left-corner))
     
     ;; Left thumb
     ((background . ,t-s-thumb-image)
      (top-edge . -16)
      (left-edge . 11)
      (width . ,(lambda (w) (- (thumb-half-width w) 5)))
      (class . title))
     
     ;; Right thumb
     ((background . ,t-s-thumb-image)
      (top-edge . -16)
      (right-edge . 23)
      (width . ,(lambda (w) (- (thumb-half-width w) 18)))
      (class . title))
     
     ;; Right
     ((background . ,t-s-right-image)
      (right-edge . -4)
      (top-edge . -16)
      (class . top-right-corner))
     
     ;; bottom shadow
     ((background . "black")
      (left-edge . -2)
      (right-edge . -5)
      (top-edge . 0)
      (height . 1))

     ;; right shadow
     ((background . "black")
      (right-edge . -5)
      (top-edge . -14)
      (height . 15)
      (width . 1))

     ;; shade button
     ((background . ,t-shade-images)
      (right-edge . -2)
      (top-edge . -13)
      (class . shade-button))
;      (class . maximize-button))
	 
     ;; maximize button
     ((background . ,t-maximize-images)
      (right-edge . 9)
      (top-edge . -13)
      (class . maximize-button))
     
     ;; delete button
     ((background . ,t-close-images)
      (left-edge . -2)
      (top-edge . -13)
      (class . close-button))
     )))

  (image-put t-top-thumb-image 'tiled t)
  (image-put t-s-thumb-image 'tiled t)
  
  (def-frame-class shade-button '((cursor . arrow))
    (bind-keys shade-button-keymap "Button1-Off" 'toggle-window-shaded))

  (add-frame-style 'Platinum
		   (lambda (w type)
                     (case type
                       ((default) frame)
		       ((transient) transient-frame)
		       ((shaped) shaped-frame)
		       ((shaped-transient) shaped-transient-frame))))
  
  ;; (call-after-property-changed 'WM_NAME update-text-width))
  (call-after-property-changed
   'WM_NAME (lambda ()
              (rebuild-frames-with-style 'Platinum))))
